PPATH  Prime Path
The ministers of the cabinet were quite upset by the
message from the Chief of Security stating that they
would all have to change the fourdigit room numbers
on their offices.
— It is a matter of security to change such things
every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good
reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also
a prime. You will just have to paste four new
digits over the four old ones on your office door.
— No, it's not that simple. Suppose that I change the
first digit to an 8, then the number will read 8033
which is not a prime!
— I see, being the prime minister you cannot stand
having a nonprime number on your door even for a
few seconds.
— Correct! So I must invent a scheme for going from
1033 to 8179 by a path of prime numbers where
only one digit is changed from one prime to the
next prime.
Now, the minister of finance, who had been eavesdropping,
intervened.
— No unnecessary expenditure, please! I happen to
know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to
minimize the cost. You don't know some very cheap
software gurus, do you?
— In fact, I do. You see, there is this programming
contest going on...
Help the prime minister to find the cheapest prime path between any two given fourdigit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033 1733 3733 3739 3779 8779 8179The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are fourdigit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Example
Input: 3 1033 8179 1373 8017 1033 1033 Output: 6 7 0
hide comments
jrseinc:
20200821 09:10:16
It is such a good question. I had no idea this type of question can be solved using BFS, worth solving. Last edit: 20200821 09:10:35 

gnomegeek:
20200804 14:19:54
AC in one go !!!!! Main task is to prepare the adj list :)


anonymousamigo:
20200803 11:07:54
BFS will be good way to solve 

noobiesag_0206:
20200718 20:48:27
Beautiful problem :) 

kumar_anubhav:
20200703 14:10:00
Good Problem !!


adikrmishra_1:
20200624 05:25:39
for solution go to this link


mercuto:
20200612 12:01:45
Tourist power activated


nandadeep_2001:
20200611 18:24:36
a gentle reminder to all pls stop posting comments like "AC in one go!!" ... etc this session is for doubt clarification not for expressing your personal feelings Last edit: 20200611 18:28:17 

kgargdunregret:
20200604 21:03:14
one of the best questions ever


chaudhary_19:
20200422 19:45:38
There is no impossible case 
Added by:  overwise 
Date:  20071002 
Time limit:  2s 
Source limit:  50000B 
Memory limit:  1536MB 
Cluster:  Cube (Intel G860) 
Languages:  All except: ERL JSRHINO NODEJS PERL6 VB.NET 
Resource:  ACM ICPC NWERC 2006 